#!/usr/bin/python
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:             Test_MODEM.py
Dev:                   Daniele De Santis
Email:                 desantis@areasx.com
Web:                   http://www.areasx.com

Versione:              0.0
Data:                  19/02/15
Note Hardware:  
Note Software: 
**********************************************************************
"""
import time
import serial
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BOARD) 
GPIO.setup(23, GPIO.OUT, initial=GPIO.LOW)  #Linea (OUTPUT) Reset Modem
GPIO.setup(15, GPIO.OUT, initial=GPIO.LOW)  #Linea (OUTPUT) Power Modem
GPIO.setup(12, GPIO.IN,  pull_up_down=GPIO.PUD_DOWN) #Linea (INPUT) Status Modem


print "Test MODEM Telit HE910"

#Controllo Modem Telit HE910
if (GPIO.input(12)==0): #Se il Modem  spento
  GPIO.output(15, True)  #Sequenza di START
  time.sleep(5.0)
  GPIO.output(15, False)
  time.sleep(10.0)
  print "Modem Acceso"
else:
  print "Modem gia' acceso"
#Inizializzazione porta Seriale
ser = serial.Serial("/dev/ttyACM0")  #Seleziona la porta seriale
ser.baudrate = 11500 #Imposta il baudrate
ser.open()

#Invio comando AT
ser.write("AT\r")
time.sleep(0.5)
rxchr=ser.inWaiting()
if(rxchr>0):
  rxbuff=ser.read(rxchr)
  print "RX:"
  print rxbuff


#Interrogazione GPS

ser.write("AT$GPSP=1\r") #Comando AT$GPSP accende GPS
time.sleep(0.5)
rxchr=ser.inWaiting()
if(rxchr>0):
  rxbuff=ser.read(rxchr)
  print "RX:"
  print rxbuff
  
time.sleep(5.0)

ser.write("AT$GPSACP?\r") #Comando AT$GPSACP recupera attuale posizione
time.sleep(0.5)
rxchr=ser.inWaiting()
if(rxchr>0):
  rxbuff=ser.read(rxchr)
  print "RX:"
  print rxbuff    

ser.close()


GPIO.cleanup()
